<?xml version="1.0" encoding="ISO-8859-1"?>

<document>

  <properties>
    <title>HttpClient Methods</title>
    <author email="adrian@ephox.com">Adrian Sutton</author>
    <revision>$Id$</revision>
  </properties>
  
  <body>

    <section name="Introduction">
      <p>These documents provide a brief introduction to using the methods
        provided by <em>HttpClient</em>.  The information here does not cover all the
      possible options, but covers enough of the basics to get you up and
      running.  For more information on the available options, refer to the <a
      href="apidocs/index.html">API Reference</a>.</p>

      <p>The examples on the following pages are not complete and are only used
      to highlight the important features that are unique to each method.  For
      complete examples, please refer to the <a
      href="http://svn.apache.org/viewcvs.cgi/jakarta/commons/proper/httpclient/trunk/src/examples/">sample
      code</a>.</p>
    </section>

    <section name="Overview">
      <table>
        <tr>
          <th>Document</th>
          <th>Description</th>
        </tr>
        <tr>
          <td><a href="methods/options.html">Options</a></td>
          <td>The OPTIONS method represents a request for information about the
          communication options available.</td>
        </tr>
        <tr>
          <td><a href="methods/get.html">Get</a></td>
          <td>The GET method means retrieve whatever information is identified
          by the requested URL.  Also refer to the
          <a href="tutorial.html">tutorial</a>.</td>
        </tr>
        <tr>
          <td><a href="methods/head.html">Head</a></td>
          <td>The HEAD method is identical to GET except that the server
          <i>must not</i> return a message-body in the response.  This method
          can be used for obtaining metainformation about the document implied
          by the request without transferring the document itself.</td>
        </tr>
        <tr>
          <td><a href="methods/post.html">Post</a></td>
          <td>The POST method is used to request that the origin server accept
          the data enclosed in the request as a new child of the request URL.
          POST is designed to allow a uniform method to cover a variety of
          functions such as appending to a database, providing data to a
          data-handling process or posting to a message board.</td>
        </tr>
        <tr>
          <td><a href="methods/multipartpost.html"><nobr>Multipart Post</nobr></a></td>
          <td>The multipart post method is identical to the POST method,
          except that the request body is separated into multiple parts.  This
          method is generally used when uploading files to the server.</td>
        </tr>
        <tr>
          <td><a href="methods/put.html">Put</a></td>
          <td>The PUT method requests that the enclosed document be stored under
          the supplied URL.  This method is generally disabled on publicly
          available servers because it is generally undesireable to allow
          clients to put new files on the server or to replace existing
          files.</td>
        </tr>
        <tr>
          <td><a href="methods/delete.html">Delete</a></td>
          <td>The DELETE method requests that the server delete the resource
          identified by the request URL.  This method is generally disabled on
          publicly available servers because it is generally undesireable to
          allow clients to delete files on the server.</td>
        </tr>
        <tr>
          <td><a href="methods/trace.html">Trace</a></td>
          <td>The TRACE method is used to invoke a remote, application-layer
          loop-back of the request message.  This allows the client to see what
          is being received at the other end of the request chain and use that
          data for testing or diagnostic information.</td>
        </tr>
      </table>
    </section>
  </body>
</document>
